REST API for Search

2010-09-03 02:27 - Akiko Takano

Status: Closed Start date: 2010-09-03

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: REST API Estimated time: 0.00 hour

Target version: 3.3.0   

Description

Some CMS or Web Application have REST API or RSS/Atom API for search function.

Since search controller don't have to implement any update/delete/create function, I suppose only an xml template is required to

support REST API.

This patch is over r4053.

Related issues:

Has duplicate Redmine - Feature #8474: [REST] search issues easily Closed 2011-05-31

Associated revisions

Revision 15262 - 2016-03-19 10:42 - Jean-Philippe Lang

REST API for Search (#6277).

Patch by Akiko Takano and Takenori TAKAKI.

Revision 15263 - 2016-03-19 10:43 - Jean-Philippe Lang

Missing fixtures (#6277).

Revision 15264 - 2016-03-19 11:27 - Jean-Philippe Lang

Handle search pagination with the REST API (#6277).

History

#1 - 2010-09-05 23:32 - Eric Davis

- Category set to REST API

I'll need some tests for this patch before it can be reviewed.

#2 - 2010-09-07 02:16 - Akiko Takano

Thanks for your taking time to see it.

I hope to apply this feature to RedmineAir if implemented.

#3 - 2013-09-08 14:05 - Christian Baus

+1 for this feature!!

i adapt the patch above for the current redmine version 2.3 and add some extension

Edit: app/controller/search_controller.rb (render part of index action)

    respond_to do |format|

        format.html { render 'search/index', :layout => !request.xhr? }

        format.api  { }

    end

 Add: app/views/search/index.xml.builder

xml.instruct!

xml.search_results :type => 'array' do

  @results.each do |result|
          xml.result do

                xml.title       result.event_title

                xml.type        result.event_type

                xml.url url_for(result.event_url(:only_path => false))

        xml.description result.event_description

        xml.datetime    result.event_datetime

if result.class == Issue

        xml.id result.id

        xml.tracker_id result.tracker_id

        xml.project_id result.project_id

        xml.subject result.subject

        xml.category_id result.category_id

        xml.assigned_to_id result.assigned_to_id

        xml.priority_id result.priority_id

        xml.author_id result.author_id

        xml.created_at result.created_on

        xml.updated_at result.updated_on

        xml.status result.status

        xml.subject result.subject

end

if result.class == Project

        xml.id result.id

        xml.parent_id result.parent_id

        xml.created_at result.created_on

        xml.updated_at result.updated_on

        xml.status result.status

        xml.name result.name

        custom_field = result.available_custom_fields.select{|f|f.name.eql?("intranet_description")}.first

        if custom_field && custom_field.custom_values

                xml.intranet_description custom_field.custom_values.first.value

        else

                xml.intranet_description "" 

        end

end

    end

  end

end

#4 - 2013-09-09 08:42 - Terence Mill

+1

#5 - 2014-02-25 09:29 - David Rahusen

+1

#6 - 2015-03-04 02:59 - Tony NG

+1

#7 - 2015-04-21 16:37 - Matthias Schelling

+1

#8 - 2015-10-13 12:24 - Dmitry Azarenko

+1

#9 - 2016-01-07 20:22 - mathew murphy

+1

#10 - 2016-01-09 06:53 - Go MAEDA

- Related to Feature #8474: [REST] search issues easily added

#11 - 2016-02-04 15:56 - Toshi MARUYAMA

- Related to deleted (Feature #8474: [REST] search issues easily)

#12 - 2016-02-04 15:56 - Toshi MARUYAMA
- Has duplicate Feature #8474: [REST] search issues easily added

#13 - 2016-02-19 02:50 - Justin Hill

+1

#14 - 2016-02-19 05:42 - Go MAEDA

- Target version set to Candidate for next major release

#15 - 2016-02-25 02:05 - Takenori TAKAKI

- File search_rest_api_trunk_r15148.patch added

I do appreciate Akiko Takano's work. I would be very happy if I could see the feature in Redmine 3.3.0.

I have updated the patch:

Compatible with latest trunk (r15148)

Added event.id to a response

Added tests

#16 - 2016-03-01 04:01 - Go MAEDA

- Target version changed from Candidate for next major release to 3.3.0

The patch created by Takenori TAKAKI works fine on the trunk (r15160) and passed all tests.

I propose to deliver this feature in Redmine 3.3.0.

#17 - 2016-03-19 11:28 - Jean-Philippe Lang

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Patch committed. I've made a few more changes to support pagination.

Thanks.

#18 - 2016-03-20 09:35 - Akiko Takano

Jean-Philippe Lang wrote:

Patch committed. I've made a few more changes to support pagination.

Thanks.

 Thank you so much for all you did!

#19 - 2016-03-20 09:39 - Akiko Takano

Hi, TAKAKI-san,

Thank you for your support and providing patch file. I really appreciate it!

Files

search_rest_api.patch 1.21 KB 2010-09-03 Akiko Takano

search_rest_api_trunk_r15148.patch 3.99 KB 2016-02-25 Takenori TAKAKI
